C        PROGRAM NEDLE2
C
C       ===================================================
C       Purpose: This program computes growth rate for
C       needle-shaped particles with a capillarity  
C       correction term. Interface kinetics is also taken
C       into account.
C       ===================================================
C
C       Copyright Pedro Rivera and H. K. D. H. Bhadeshia,
C       University of Cambridge, 1999
C

       IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER(I,J,L)
       DOUBLE PRECISION PEC(20010), N1(20010), N2(20010)
       DOUBLE PRECISION A(3)
       DOUBLE PRECISION JN1,JN2,R1P,R2P,K,KP,KM
       DOUBLE PRECISION R1PM,R2PM,R1PP,R2PP
       DOUBLE PRECISION DR1P,DR2P,DK,DKP
       DOUBLE PRECISION JJN1,JJN2,NDR1P,NDR2P
       DOUBLE PRECISION CP,CDN,DEN1,DEN2,JN1B,JN2B
       PI = 3.141592654
       IN1 = 1             
       OU2 = 2
       OU3 = 3
      OPEN(UNIT = IN1,FILE='indat11.d')
      OPEN(UNIT = OU2,FILE='res1.d')

       READ(IN1,*) Q
      DO 10 I=1,38
       READ(IN1,*) PEC(I), N1(I), N2(I)
10    CONTINUE

      DO 13 L=1,99
      O=0.0d0+L*0.01
       P=1D-4
       DP=1D-5
      
      DO 20 I=0,40000
       DP=1D-5
      R = 10**(0.0001*I)
      II=0
23    IF (P-DP.LE.1.0D-12) THEN
       DP=P
       PP=P+DP
       PM=P-0.9D0*DP
      ELSE
       PP=P+DP
       PM=P-DP
       P=(PM+PP)/2.0D0
      ENDIF
      CALL E1XB(P,ERP)
      CALL E1XB(PP,ERPP)
      CALL E1XB(PM,ERPM)
      DO 25 J=1,38
        IF ((PEC(J).LE.P).AND.(PEC(J+1).GE.P)) THEN
         JN1=N1(J)+((N1(J+1)-N1(J))/
&        (PEC(J+1)-PEC(J)))*(P-PEC(J))
         JJN1=JN1
         JN2=N2(J)+((N2(J+1)-N2(J))/
&        (PEC(J+1)-PEC(J)))*(P-PEC(J))
         JJN2=JN2
         R1P=(1.0D0/(2*P))*JN1-1.0D0
         R2P=(1.0D0/(4*P))*JN2-1.0D0
         GOTO 30
        ENDIF
25     CONTINUE

30     DO 35 J=1,38
        IF ((PEC(J).LE.PP).AND.(PEC(J+1).GE.PP)) THEN
         JN1=N1(J)+((N1(J+1)-N1(J))/
&        (PEC(J+1)-PEC(J)))*(PP-PEC(J))
         JN2=N2(J)+((N2(J+1)-N2(J))/
&        (PEC(J+1)-PEC(J)))*(PP-PEC(J))
         R1PP=(1.0D0/(2*PP))*JN1-1.0D0
         R2PP=(1.0D0/(4*PP))*JN2-1.0D0
         GOTO 40
        ENDIF
35     CONTINUE 
40     DO 45 J=1,38
        IF ((PEC(J).LE.PM).AND.(PEC(J+1).GE.PM)) THEN
         JN1=N1(J)+((N1(J+1)-N1(J))/
&        (PEC(J+1)-PEC(J)))*(PM-PEC(J))
         JN2=N2(J)+((N2(J+1)-N2(J))/
&        (PEC(J+1)-PEC(J)))*(PM-PEC(J))
         R1PM=(1.0D0/(2*PM))*JN1-1.0D0
         R2PM=(1.0D0/(4*PM))*JN2-1.0D0
         GOTO 50
        ENDIF
45      CONTINUE



50     K=P*DEXP(P)*ERP*(1.0D0+
&      2.0D0*(1.0D0/R)*(P/Q)*O*R1P+(1.0D0/R)*O*R2P)-O
       KP=PP*DEXP(PP)*ERPP*(1.0D0+
&      2.0D0*(1.0D0/R)*(PP/Q)*O*R1PP+(1.0D0/R)*O*R2PP)-O
       KM=PM*DEXP(PM)*ERPM*(1.0D0+
&      2.0D0*(1.0D0/R)*(PM/Q)*O*R1PM+(1.0D0/R)*O*R2PM)-O

       IF ((K.GT.0.0D0).AND.(KP.GT.0.0D0).AND.
&       (KM.GT.0.0D0)) THEN
        II=II+1
        IF (II.EQ.1) THEN
          A(II)=P
        ENDIF
        IF (II.EQ.2) THEN
          A(II)=P
        ENDIF
        IF (II.EQ.3) THEN
          A(II)=P
        ENDIF
        IF ((II.EQ.3).AND.(A(1).EQ.A(3))) THEN
          GOTO 20
        ENDIF
        IF (II.EQ.3) THEN
          II=0
        ENDIF
        IF (KM.LT.K) THEN
         P=P-DP
        ELSE
         P=P+DP
        ENDIF
       GOTO 60
       ENDIF
       IF ((K.LT.0.0D0).AND.(KP.LT.0.0D0).AND.
&       (KM.LT.0.0D0)) THEN
        PA=P
        IF (KP.GT.K) THEN
         P=P+DP
        ELSE
         P=P-DP
        ENDIF
       GOTO 60       
       ENDIF
       DP=DP/2.0D0
       IF (((K.GT.0.0D0).AND.(KP.LT.0.0D0)).OR.
&       ((K.LT.0.0D0).AND.(KP.GT.0.0D0))) THEN
        P=P+DP
       ELSE
        P=P-DP
       ENDIF
60    IF (DP.GE.1D-10) THEN
        GOTO 23
      ENDIF

C =======================================================
C CALCULATION OF THE FIRST ORDER DERIVATIVE

       IF (P.LE.3.0D0) THEN
        CP=P+0.1D0
        CDN=0.1D0
       ENDIF
       IF (P.GT.3.0D0) THEN
        CP=P+1.0D0
        CDN=1.0D0
       ENDIF
       DO 70 J=1,38
       IF ((PEC(J).LE.CP).AND.(PEC(J+1).GE.CP)) THEN
        JN1B=N1(J)+((N1(J+1)-N1(J))/
&       (PEC(J+1)-PEC(J)))*(CP-PEC(J))
        JN2B=N2(J)+((N2(J+1)-N2(J))/
&       (PEC(J+1)-PEC(J)))*(CP-PEC(J))
        DEN1=(JN1B-JJN1)/CDN
        DEN2=(JN2B-JJN2)/CDN
       ENDIF
70     CONTINUE
 
       NDR1P=-JJN1/(2.0D0*P**2.0D0)+DEN1/(2.0D0*P)
       NDR2P=-JJN2/(4.0D0*P**2.0D0)+DEN2/(4.0D0*P)

       DR1P=(r1pp-r1pm)/(pp-pm)
       DR2P=(r2pp-r2pm)/(pp-pm)

       IF (LL.EQ.1) THEN
        DR1P=NDR1P
        DR2P=NDR2P
       ENDIF

95     DK=((P*DEXP(P)*ERP)**2.0D0)*(1.0D0/R)*(2.0D0*P
&       *DR1P/Q-R2P/P+DR2P)+DEXP(P)*ERP+P*DEXP(P)*ERP-1.0D0
       IF (DK.LT.0) THEN
        LL=1
       ELSE
        LL=0
       ENDIF
       IF (((DKP.LT.0).AND.(DK.GT.0))) THEN
        RRR=R
        write(OU2,200) o,rrr,p       
        GOTO 13
       ENDIF
       DKP=DK
20    CONTINUE

13    CONTINUE

200    FORMAT(1X,4D15.5)
999    STOP
       END
        
        SUBROUTINE E1XB(X,E1)
C
C       ============================================
C       Purpose: Compute exponential integral E1(x)
C       Input :  x  --- Argument of E1(x)
C       Output:  E1 --- E1(x)  ( x > 0 )
C       ============================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        IF (X.EQ.0.0) THEN
           E1=1.0D+300
        ELSE IF (X.LE.1.0) THEN
           E1=1.0D0
           R=1.0D0
           DO 10 K=1,25
              R=-R*K*X/(K+1.0D0)**2
              E1=E1+R
              IF (DABS(R).LE.DABS(E1)*1.0D-15) GO TO 15
10         CONTINUE
15         GA=0.5772156649015328D0
           E1=-GA-DLOG(X)+X*E1
        ELSE
           M=20+INT(80.0/X)
           T0=0.0D0
           DO 20 K=M,1,-1
              T0=K/(1.0D0+K/(X+T0))
20         CONTINUE
           T=1.0D0/(X+T0)
           E1=DEXP(-X)*T
        ENDIF
        RETURN
        END


